
#ifndef CATR_H
#define CATR_H

#include "rtree.h"
#include "config.h"
#include "set.h"
#include "CSTree.h"

rtreeGroup *rtree_buildMultipleTreeAndFindGlobalSkyline(config *aConfig, projTableWhole *projTabWhole, mySet *remainD, mySet *globalSkyline);
rtreeGroup *rtree_buildSingleTreeAndFindGlobalSkyline(config *aConfig, projTableWhole *projTabWhole, mySet *remainD, mySet *globalSkyline);

//void rtree_start(config *aConfig, int l_m, int l_M, int l_reinsert_p);
void rtree_start(config *aConfig);


//void rtree_findSkyline_node(record *data, config *aConfig, rtreeGroup *anRtreeGroup, mySet *totalS, STNode *aChild, int dimNo, int rtreeClassIndex);

rtreeGroup *rtree_buildMultipleTreeAndFindLocalSkyline_preprocess(config *aConfig, projTableWhole *projTabWhole) ;
//void rtree_findSkyline_preprocess(record *data, config *aConfig, rtreeGroup *anRtreeGroup, mySet *totalS, int dimNo, int rtreeClassIndex, int classID);

//void rtree_findSkyline_preprocess(record *data, config *aConfig, rtreeGroup *anRtreeGroup, mySet *totalS, int dimNo, int rtreeClassIndex, int classID, myClassSet *projDimClass);

//void rtree_findSkyline_node(record *data, config *aConfig, rtreeGroup *anRtreeGroup, mySet *totalS, STNode *aChild, int rtreeClassIndex, myOrderSet *anOrderSet);
void rtree_findSkyline_node(record *data, config *aConfig, rtreeGroup *anRtreeGroup, mySet *totalS, STNode *aChild, int rtreeClassIndex, myOrderSet *anOrderSet, myClassSet *projDimClass);

void rtree_findSkyline_preprocess(record *data, config *aConfig, rtreeGroup *anRtreeGroup, mySet *totalS, int dimNo, int rtreeClassIndex, myClassSet *projDimClass);


#endif
