
#include "lattice.h"

mySet *lattice_findSkylineIntersection(mySet ***latticeStorage, myOrderSet *anOrderSet)
{
	mySet *returnValue;
	int i, j, k;

	int noOfClass;
	int dimNo;

	mySet *anOrderList;

	int *elt;

	int index1, index2;

	int isStart;

	returnValue = set_new();

	isStart = 1;
	for (i = 0; i < anOrderSet->noOfElt; i++)
	{
		dimNo = anOrderSet->dimNo[i];
		anOrderList = anOrderSet->orderList[i];

		noOfClass = anOrderList->noOfElt;
		elt = anOrderList->elt;

		for (j = 0; j < noOfClass; j++)
		{
			index1 = elt[j];
			for (k = j+1; k < noOfClass; k++)
			{
				index2 = elt[k];

				if (isStart == 1)
				{
					set_copy(returnValue, latticeStorage[index1][index2]);
					isStart = 0;
				}
				else
				{
					set_intersection(returnValue, latticeStorage[index1][index2]);
				}
			}
		}
	}

	return returnValue;
}
